#!/usr/bin/perl

  require 'webmin-lib.pl';
  require '/usr/webtool/guardiandigital-lib.pl';
  use Socket;
  &ReadParse();


  ### Make sure we won't lock ourselves out, and build IP list.
  if ($in{"access"}) {
    @hosts = split(/\s+/, $in{"ip"});
    if (!@hosts) { &PrintError("Please enter at least one IP address."); exit; }

    $raddr = $ENV{'REMOTE_ADDR'};

    foreach $h (@hosts) {
      if ($h =~ /^([0-9\.]+)\/([0-9\.]+)$/) {
        if (!&check_ipaddress($1)) {
          &PrintError("'$1' is not a valid network address.");
          exit;
        }

        if (!&check_ipaddress($2)) {
          &PrintError("'$1' is not a valid netmask.");
          exit;
        }

        $i = $h;
      }
      elsif ($h =~ /^[0-9\.]+$/) {
        if (!&check_ipaddress($h)) {
          &PrintError("'$h' is not a complete IP address");
          exit;
        }
        $i = $h;
      }
      elsif (!($i = join('.', unpack("CCCC", inet_aton($h))))) {
        &PrintError("Could not find an IP address for '$h'");
        exit;
      }

      push(@ip, $i);
    }

    if ($in{"access"} == 1 && !&ip_match($raddr, @ip) ||
        $in{"access"} == 2 && &ip_match($raddr, @ip)) {
      &PrintError("Failed to update:  Your currrent IP ($raddr) would be denied!");
      exit;
    }
  }

  ### Make changs to config the restart the daemon.
  &get_miniserv_config(\%miniserv);
    delete($miniserv{"allow"});
    delete($miniserv{"deny"});
    if ($in{"access"} == 1) { $miniserv{"allow"} = join(' ', @hosts); }
    elsif ($in{"access"} == 2) { $miniserv{"deny"} = join(' ', @hosts); }
  &put_miniserv_config(\%miniserv);

  ### Won't you step into the freezer....
  &redirect("/Security/");

  &restart_miniserv();
  sleep 2;


### ############################################################################
### ip_match(ip, [match]+)
### Checks an IP address against a list of IPs, networks and networks/masks
### ############################################################################
sub ip_match {
  local(@io, @mo, @ms, $i, $j);

  @io = split(/\./, $_[0]);

  for($i=1; $i<@_; $i++) {
    local $mismatch = 0;

    ### Compare with network/mask.
    if ($_[$i] =~ /^(\S+)\/(\S+)$/) {
      @mo = split(/\./, $1); @ms = split(/\./, $2);
      for($j=0; $j<4; $j++) {
        if ((int($io[$j]) & int($ms[$j])) != int($mo[$j])) { $mismatch = 1; }
      }
    }

    ### Compare with IP or network.
    else {
      @mo = split(/\./, $_[$i]);
      while(@mo && !$mo[$#mo]) { pop(@mo); }
      for($j=0; $j<@mo; $j++) { if ($mo[$j] != $io[$j]) { $mismatch = 1; } }
    }

    ### If we had an error then signify.
    return 1 if (!$mismatch);
  }

  ### Return normally.
  return 0;
}

