#!/usr/bin/perl

  ### Startup Stuff
  require './StatusMonitor.pl';
  &init_config();

  ### ############################### ###
  ### Get the output of /bin/netstat. ###
  ### ############################### ###
  $netstat = `/bin/netstat --inet -l -n`;
  @netstat_lines = split /\n/, $netstat;

  $chkconfig = `/sbin/chkconfig --list`;
  @chkconfig_lines = split /\n/, $chkconfig;

  ### ###################### ###
  ### Setup _stat variables. ###
  ### ###################### ###
  $ssh_stat     = grep /\:22\ /,   @netstat_lines;
  $postfix_stat = grep /\:25\ /,   @netstat_lines;
  $named_stat   = grep /\:53\ /,   @netstat_lines;
  $apache_stat  = grep /\:80\ /,   @netstat_lines;
  $ntp_stat     = grep /\:123\ /,  @netstat_lines;
  $imapd_stat   = grep /\:993\ /,  @netstat_lines;
  $pop3d_stat   = grep /\:995\ /,  @netstat_lines;
  $upass_stat   = grep /\:1022\ /, @netstat_lines;

  ### ####################### ###
  ### Setup _start variables. ###
  ### ####################### ###
  $ssh_start     = grep /^sshd.*3\:on/,          @chkconfig_lines;
  $postfix_start = grep /^postfix.*3\:on/,       @chkconfig_lines;
  $named_start   = grep /^named.*3\:on/,         @chkconfig_lines;
  $apache_start  = grep /^httpd.*3\:on/,         @chkconfig_lines;
  $ntp_start     = grep /^xntpd.*3\:on/,         @chkconfig_lines;
  $imapd_start   = grep /^stunnel-imap.*3\:on/,  @chkconfig_lines;
  $pop3d_start   = grep /^stunnel-pop3.*3\:on/,  @chkconfig_lines;
  $upass_start   = grep /^userpass.*3\:on/,      @chkconfig_lines;   


  ### ########################### ###
  ### Setup _startstat variables. ###
  ### ########################### ###
  if ($ssh_start) { $ssh_startstat = "Yes"; }
  else { $ssh_startstat = "No"; }
  if ($postfix_start) { $postfix_startstat = "Yes"; }
  else { $postfix_startstat = "No"; }
  if ($named_start) { $named_startstat = "Yes"; }
  else { $named_startstat = "No"; }
  if ($apache_start) { $apache_startstat = "Yes"; }
  else { $apache_startstat = "No"; }
  if ($ntp_start) { $ntp_startstat = "Yes"; }
  else { $ntp_startstat = "No"; }
  if ($imapd_start) { $imapd_startstat = "Yes"; }
  else { $imapd_startstat = "No"; }
  if ($pop3d_start) { $pop3d_startstat = "Yes"; }
  else { $pop3d_startstat = "No"; }
  if ($upass_start) { $upass_startstat = "Yes"; }
  else { $upass_startstat = "No"; }

  ### #################################### ###
  ### Setup our $c, $s, and $ss variables. ###
  ### #################################### ###
  if ($ssh_stat) { $c22 = "GREEN"; $s22 = "OK"; $ss22 = "Stop"; }
  else { $c22 = "RED"; $s22 = "OFF"; $ss22 = "Start"; }
  if ($postfix_stat) { $c25 = "GREEN"; $s25 = "OK"; $ss25 = "Stop"; }
  else { $c25 = "RED"; $s25 = "OFF"; $ss25 = "Start"; }
  if ($named_stat) { $c53 = "GREEN"; $s53 = "OK"; $ss53 = "Stop"; }
  else { $c53 = "RED"; $s53 = "OFF"; $ss53 = "Start"; }
  if ($apache_stat) { $c80 = "GREEN"; $s80 = "OK"; $ss80 = "Stop"; }
  else { $c80 = "RED"; $s80 = "OFF"; $ss80 = "Start"; }
  if ($ntp_stat) { $c123 = "GREEN"; $s123 = "OK"; $ss123 = "Stop"; }
  else { $c123 = "RED"; $s123 = "OFF"; $ss123 = "Start"; }
  if ($imapd_stat) { $c993 = "GREEN"; $s993 = "OK"; $ss993 = "Stop"; }
  else { $c993 = "RED"; $s993 = "OFF"; $ss993 = "Start"; }
  if ($pop3d_stat) { $c995 = "GREEN"; $s995 = "OK"; $ss995 = "Stop"; }
  else { $c995 = "RED"; $s995 = "OFF"; $ss995 = "Start"; }
  if ($upass_stat) { $c1022 = "GREEN"; $s1022 = "OK"; $ss1022 = "Stop"; }
  else { $c1022 = "RED"; $s1022 = "OFF"; $ss1022 = "Start"; }


  ### Print the pretty header.
  &header("Services Monitor", 0, 0);

print <<EOF;
<BR><CENTER><TABLE BORDER="0" WIDTH="470" CELLSPACING="0" CELLPADDING="0">
  <TR $tb><TD COLSPAN="5">
    <DIV CLASS=ttitle><B>Services Monitor</B></DIV>
  </TD></TR>

  <TR $cb><TD COLSPAN="5"><DIV CLASS=nbody>
   Below you can see which services are currently running on your machine.  
   You can start or stop them by clicking on the "Start" or "Stop" link.
  </TD></TR>

  <TR $cb><TD COLSPAN="5">&nbsp;</TD></TR>

  <TR><TD COLSPAN="5">&nbsp;</TD></TR>

  <TR $tb>
    <TD><DIV CLASS=thead><B>Port</B></DIV></TD>
    <TD><DIV CLASS=thead><B>Service</B></DIV></TD>
    <TD><DIV CLASS=thead><B>Status</B></DIV></TD>
    <TD><DIV CLASS=thead><B>State</B></DIV></TD>
    <TD><DIV CLASS=thead><B>Active at Boot?</B></DIV></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>22</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>Secure Shell Services</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c22">$s22</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss22.cgi?s=sshd">$ss22</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=sshd&rv=$ssh_start">$ssh_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>25</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>Mail Services</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c25">$s25</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss25.cgi?s=postfix">$ss25</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=postfix&rv=$postfix_start">$postfix_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>53</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>DNS Services</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c53">$s53</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss53.cgi?s=named">$ss53</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=named&rv=$named_start">$named_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>80</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>WWW Services</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c80">$s80</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss80.cgi?s=httpd">$ss80</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=httpd&rv=$apache_start">$apache_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>123</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>Network Time Protocol</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c123">$s123</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss123.cgi?s=xntpd">$ss123</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=xntpd&rv=$ntp_start">$ntp_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>993</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>IMAP Services</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c993">$s993</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss993.cgi?s=stunnel-imap">$ss993</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=stunnel-imap&rv=$imapd_start">$imapd_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>995</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>POP Services</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c995">$s995</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss995.cgi?s=stunnel-pop3">$ss995</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=stunnel-pop3&rv=$pop3d_start">$pop3d_startstat</A></B></TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS=nbody><B>1022</B></DIV></TD>
    <TD><DIV CLASS=nbody><B>User Password Changer</B></DIV></TD>
    <TD><DIV CLASS=nbody><B><FONT COLOR="$c1022">$s1022</FONT></B></DIV></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_$ss1022.cgi?s=userpass">$ss1022</A></B></TD>
    <TD><DIV CLASS=nbody><B><A HREF="services_atboot.cgi?s=userpass&rv=$upass_start">$upass_startstat</A></B></TD>
  </TR>

  <TR $cb><TD COLSPAN="5">&nbsp;</TD></TR>

</TABLE></CENTER>

<CENTER><TABLE BORDER="0" WIDTH="470" CELLSPACING="0" CELLPADDING="0">
  <TR $cb><TD COLSPAN="3">&nbsp;</TD></TR>

  <TR $cb>
    <TD ALIGN="CENTER">
      <DIV CLASS=nbody><B>
        <A HREF="system_reboot.cgi">[ Reboot System ]</A>
      </B></DIV>
    </TD>
    <TD>&nbsp;</TD>
    <TD ALIGN="CENTER">
      <DIV CLASS=nbody><B>
        <A HREF="system_shutdown.cgi">[ Shutdown System ]</A>
      </B></DIV>
    </TD>
  </TR>

  <TR $cb><TD COLSPAN="3">&nbsp;</TD></TR>
</TABLE></CENTER><P>
EOF

  ### Go home.
  &ryanFooter(" ");
