#!/usr/bin/perl

  do '/usr/webtool/web-lib.pl';
  &init_config();


### ########################################################
### codeToText():  Translate a code into a text description.
### ########################################################

sub codeToText() {
  local $code;
  ($code) = @_;

  @keys = keys %text;

  foreach (@keys) {
    if ($text{$_} eq $code) {
      ($good, $bad) = split /\_/, $_;
      $str = $good . "_name";

      return $text{$str};
      
    }
  }


}


### ##########################################
### listSavedBackups():  List current backups.
### ##########################################

sub listSavedBackups() {
  ($when) = @_;

  local @files;
  @crons = glob("/etc/cron.$when/*");
  @backups = &listBackups('code');

  foreach $x (@crons) {
    $x =~ s/.*\/([^\/]+)$/$1/;

    foreach $b (@backups) {
      if ($b eq $x) {
        push (@files, $x);
      }
    }
  }
  

  return @files;
}

### #############################################
### listBackups():  List available backups types.
### #############################################

sub listBackups() {
  ($type) = @_;
  local $code, $name, @backups, $i;

  $i = 0;
  open FILE, "lang/en";

  if ($type eq "desc") {
    while (<FILE>) {
      chomp $_;

      if ($_ =~ m/(backup|ub)[0-9]+_name/) { 
        ($code, $name) = split /\=/, $_;

        $backups[$i]->{'code'} = $code;
        $backups[$i++]->{'name'} =  $name;
      }
    }
  }
  elsif ($type eq "code") {
    while (<FILE>) {
      chomp $_;

      if ($_ =~ m/(backup|ub)[0-9]+_file/) { 
        ($code, $name) = split /\=/, $_;

        $backups[$i++] = $name;
      }
    }
  }
  close FILE;

  return @backups;
}


### ##############################################################
### tarballToCode():  Translate a tarball path into a backup code.
### ##############################################################
sub tarballToCode() {
  ($code) = @_;

  $tmp = $config{'backupDir'};
  $tmp =~ s/\//\\\//g;
  $code =~ s/$tmp\///g;                     ### Take out the parent dir.
  $code =~ s/\-\-.*//g;                     ### Take out the date stuff.

  return $code;
}


### ###################################################################
### readPresetBackups():  Read backups.desc and return in assoc. array.
### ###################################################################
sub readPresetBackups() {
  my ($i, @backups);
  $i = 0;

  &obtain_lock("backups.desc");
  open BACKUPS, "backups.desc";

    while (<BACKUPS>) {
      if ($_ =~ m/([^\=]*)\=(.*)/) {
        $backups[$i]{'key'} = "$1";
        $backups[$i]{'value'} = "$2";
        $i++;
      }
    }

  close BACKUPS;
  &release_lock("backups.desc");

  return @backups;
}


### #############################################
### getBackupArgs()
### #############################################

sub getBackupArgs() {
  my ($code, $name, @backups, $i);
  ($code) = @_;

  $i = 0;
  open FILE, "lang/en";

  while (<FILE>) {
    chomp $_;

    if ($_ =~ m/^$code/) { 
      ### Get the filename.
      $tmp = <FILE>;
      ($args{'file'}) = ($tmp =~ m/.*\ \=\ (.*)$/);

      ### Get the arguments.
      $tmp = <FILE>;
      ($args{'args'}) = ($tmp =~ m/.*\ \=\ (.*)$/);
  
      return %args;
    }
  }

  return %args;
}


### ##########################################
### listSavedBackups():  List current backups.
### ##########################################

sub listTarballs() {
  ($directory) = @_;

  local @files;
  @tarballs = glob("$directory/*.tar.gz");
  @backups = &listBackups('code');


  $i = 0;
  foreach $t (@tarballs) {
    foreach $b (@backups) {
      if ($t =~ m/\/$b/) {
        $files[$i]->{'path'} = $t;
        $files[$i]->{'name'} = $b;
        ($files[$i++]->{'date'}) = ($t =~ m/([0-9]{4}\-[0-9]{2}\-[0-9]{2})/);
      }
    }

  }

  return @files;
}

  ### ###############################################################
  ### PrintError()
  ### ###############################################################
  ### Used to pop up a JavaScript with a $message then return user to
  ### previous page.
  ### ###############################################################

  sub PrintError {
    my ($message) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go(-1);
  </SCRIPT>
</HEAD>
</HTML>
ErrorEOF
  }

