#!/usr/bin/perl

  require './bind8-lib.pl';
  &ReadParse();

  &error_setup($in{'type'} ? $text{'screate_err1'} : $text{'screate_err2'});
  %access = &get_module_acl();
  $access{'slave'} || &error($in{'type'} ? $text{'screate_ecannot1'}
                                         : $text{'screate_ecannot2'});
  $access{'ro'} && &error($text{'master_ero'});

  ### validate inputs
  if ($in{'rev'}) {
    $in{'zone'} =~ /^[0-9\.]+$/ || &error(&text('screate_enet', $in{'zone'}));

    ### Make sure it's a valid network number.
    if ($in{'zone'} !~ m/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/) {
      &PrintError("$in{'zone'} is not a valid network address.");
      exit;
    }

    ### Lop off the trailing ".[0-9]{3}" for our in-addr.arpa record.
    else { $in{'zone'} =~ s/\.[0-9]$//; }


    $in{'zone'} = &ip_to_arpa($in{'zone'});
  }
  else {
    $in{'zone'} =~ /^[A-z0-9\-\.]+$/ ||
       &error(&text('screate_edom', $in{'zone'}));
  }

  $in{'zone'} =~ s/\.$//g;
  @masters = split(/\s+/, $in{'masters'});

  foreach $m (@masters) {
    &check_ipaddress($m) || &error(&text('screate_emaster', $m));
  }

  if (!@masters) { &error($text{'screate_enone'}); }

  $base = $config{'slave_dir'} ? $config{'slave_dir'} :
          $access{'dir'} eq '/' ? &base_directory($conf) : $access{'dir'};

  ### ###################################################################### ###
  ### This segement of code is never used since we disable file definitions. ###
  ### ###################################################################### ###
  if ($in{'file_def'} == 0) {
    $in{'file'} =~ /^\S+$/ || &error(&text('screate_efile', $in{'file'}));
    $in{'file'} =~ s/^$config{'chroot'}//;

    if ($in{'file'} !~ /^\//) { $file = $base."/".$in{'file'}; }
    else { $file = $in{'file'}; }

    &allowed_zone_file(\%access, $file) ||
      &error(&text('screate_efile2', $file));

    open(ZONE, "> $config{'chroot'}$file") ||
      &error(&text('screate_efile3', $file, $!));
    close(ZONE);
  }
  elsif ($in{'file_def'} == 2) {
    if ($in{'rev'}) { $file = $base."/".&arpa_to_ip($in{'zone'}).".rev"; }
    else { $file = $base."/".$in{'zone'}.".soa"; }
  }
  ### ###################################################################### ###
  ### This segement of code is never used since we disable file definitions. ###
  ### ###################################################################### ###


  ### Create zone directive
  &lock_file($config{'chroot'}.$config{'named_conf'});
  open(CONF, ">>$config{'chroot'}$config{'named_conf'}");
    print CONF "zone \"$in{'zone'}\" {\n";
    print CONF "	type slave;\n";
    print CONF "	file \"slave/db.$in{'zone'}\";\n";

    print CONF "	masters {\n";
    foreach $m (@masters) { print CONF "		$m;\n"; }
    print CONF "	};\n";

    print CONF "	allow-transfer { none; };\n";

    ### allow-query sub-statement.
    if ($in{'allow-query_def'} == 0) {
      @queries = split /\s+/, $in{'allow-query'};
      $i = 0;

      foreach $q (@queries) {
        if ($i == 0) { print CONF "	allow-query { $q; "; }
        else { print CONF "$q; "; }
        $i++;
      }

      print CONF "};\n";
    }

    print CONF "};\n\n";
  close(CONF);
  &unlock_file($config{'chroot'}.$config{'named_conf'});


  ### Add the new zone to the access list
  #if ($access{'zones'} ne '*') {
    #$access{'zones'} .= " ".$in{'zone'};
    #&save_module_acl(\%access);
  #}


  &RestartNamed();

  &redirect("");

