#!/usr/bin/perl

  require './bind8-lib.pl';

  &header($text{'index_title'}, "", undef, 1, 1);
  %access = &get_module_acl();

  $confpath  = $config{'chroot'};
  $confpath .= $config{'named_conf'};


  ### Check if bind is installed
  if (!(-x $config{'named_path'})) {
    print "<p>",&text('index_enamed', "<tt>$config{'named_path'}</tt>",
          "/config.cgi?$module_name"),"<p>\n";
    &ryanFooter("/SystemManager/");
    exit;
  }


  ### Check if BIND is the right version.. Only BIND 8 offers the -f option
  ### Is there a better way to do this?
  $out = `$config{'named_path'} -help 2>&1`;
  if ($out !~ /\[-f\]/) {
    print "<p>",&text('index_eversion', "<tt>$config{'named_path'}</tt>",
          "/dnsadmin/"),"<p>\n";
    &ryanFooter("/SystemManager/");
    exit;
  }


  ### display global options
print <<OPTIONS;
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
<TR><TD $tb COLSPAN=2><DIV CLASS=ttitle><B>DNS Management</B></DIV></TD></TR>
<TR><TD $cb COLSPAN=2>&nbsp;</TD></TR>
<TR $cb>
  <TD WIDTH=20>&nbsp;</TD>
  <TD>
    <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>

    <TR><TD $tb COLSPAN=2><DIV CLASS=thead><B>$text{'index_opts'}</TD></TR>
    <TR><TD $cb COLSPAN=2>&nbsp;</TD></TR>

    <TR>
      <TD $cb><DIV CLASS=nbody><B>
        <A HREF="conf_zoneoptions.cgi">Global Options</A>
      </TD>
      <TD $cb><DIV CLASS=nbody>
        Setup forwarders and various defaults that will apply to all the zones you manage.
      </TD>
    </TR>

    <TR><TD $cb COLSPAN=2>&nbsp;</TD></TR>

    <TR>
      <TD $cb><DIV CLASS=nbody><B>
        <A HREF="master_form.cgi">Create a New Master Zone</A>
      </TD>
      <TD $cb><DIV CLASS=nbody>
       Create a new authoritative zone.
      </TD>
    </TR>

    <TR><TD $cb COLSPAN=2>&nbsp;</TD></TR>

    <TR>
      <TD $cb><DIV CLASS=nbody><B>
        <A HREF="slave_form.cgi">Create a New Slave Zone</A>
      </TD>
      <TD $cb><DIV CLASS=nbody>
       Create a new secondary zone.
      </TD>
    </TR>


    </TABLE>
  </TD>
</TR>

<TR><TD $cb COLSPAN=2> &nbsp; </TD></TR>
<TR><TD $cb COLSPAN=2> &nbsp; </TD></TR>

OPTIONS


  $conf = &get_config();
  @zones = &find("zone", $conf);


  if (@zones > $config{'max_zones'}) {
    print "<TR $tb>\n";
    print "  <TD COLSPAN=2><DIV CLASS=thead><B>$text{'index_zones'}</TD>\n";
    print "</TR>\n\n";

    print "<TR $cb>\n";
    print "  <TD COLSPAN=2><DIV CLASS=nbody>\n";
    print "    <p>$text{'index_toomany'}<p>\n";
    print "  </TD>\n";
    print "</TR>\n\n";

    print "<TR $cb>\n";
    print "  <TD COLSPAN=2>\n";
    print "    <form action=find_zones.cgi>\n";
    print "    <FONT FACE=Arial,Helvetica,Sans-Serif>\n";
    print "    &nbsp;&nbsp;&nbsp;&nbsp;<b>$text{'index_find'}</b></FONT>\n";
    print "    <input name=search size=20>\n";
    print "    <FONT FACE=Arial,Helvetica,Sans-Serif>\n";
    print "    <input type=submit value='$text{'index_search'}'>&nbsp;\n";
    print "    <A HREF=find_zones.cgi?search=.><B>[ View All Zones ]</B></A>\n";
    print "    <P></FORM>\n";
  }
  elsif (@zones) {
    print "<TR><TD $tb COLSPAN=2><DIV CLASS=thead><B>$text{'index_zones'}</TD></TR>\n";
    print "<TR><TD $cb COLSPAN=2>\n";
    print "<table width=100%>\n";

    foreach $z (@zones) {
      $v = $z->{'value'};

      next if ($v eq "." || !&can_edit_zone(\%access, $v));
      next if (($v eq "0.0.127.in-addr.arpa") || ($v eq "bind") ||
               ($v eq "localhost") || ($v eq "cache"));

      $tv = &find("type", $z->{'members'});
      next if (!$tv);
      $t = $tv->{'value'};
      push(@zlinks, "edit_$t.cgi?index=$z->{'index'}");
      push(@ztitles, &arpa_to_ip($v));
      push(@zicons, "images/$t.gif");
      push(@ztypes, $text{"index_$t"});
      $len++;
    }

    ### sort list of zones
    @zorder = sort { $ztitles[$a] cmp $ztitles[$b] } (0 .. $len-1);
    @zlinks = map { $zlinks[$_] } @zorder;
    @ztitles = map { $ztitles[$_] } @zorder;
    @zicons = map { $zicons[$_] } @zorder;
    @ztypes = map { $ztypes[$_] } @zorder;

    ### display as list
    $mid = int((@zlinks+1)/2);
    print "<table width=100%><tr><td width=50% valign=top>\n";
    &zones_table([ @zlinks[0 .. $mid-1] ], [ @ztitles[0 .. $mid-1] ],
                 [ @ztypes[0 .. $mid-1] ]);
    print "</td><td width=50% valign=top>\n";

    if ($mid < @zlinks) {
      &zones_table([ @zlinks[$mid .. $#zlinks] ],
                   [ @ztitles[$mid .. $#ztitles] ],
                   [ @ztypes[$mid .. $#ztypes] ]);
    }

    print "</td></tr></table>\n";
  }
  else {
    print "<TR $cb>\n";
    print "  <TD COLSPAN=2 ALIGN=CENTER>\n";
    print "    <DIV CLASS=nbody><B>$text{'index_none'}</B></DIV>\n";
    print "  </TD>\n";
    print "</TR>\n";
    print "<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>\n\n";
    print "</TABLE>\n";
  }

  ### get pid (if any)
  if (($opts = &find("options", $conf)) &&
      ($pidopt = &find("pid-file", $opts->{'members'}))) {
        # read from PID file
        $pidfile = $pidopt->{'value'};
  }
  else { $pidfile = "/var/run/named.pid"; }


  print "<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>\n";
  print "</TABLE></CENTER><P>\n";

  &ryanFooter("/SystemManager/");




sub dump_config {
  local($c);

  foreach $c (@{$_[0]}) {
    print "$_[1]$c->{'name'} ", join(',', @{$c->{'values'}});

    if ($c->{'type'}) {
      print " {\n";
      &dump_config($c->{'members'}, "$_[1]\t");
      print "$_[1]}\n";
    }
    else { print "\n"; }
  }
}

sub zones_table {
  local($i);

  print "<TABLE BORDER WIDTH=100%>\n";
  print "<TR $tb>\n";
  print "  <TD><B>$text{'index_zone'}</B></TD>\n";
  print "  <TD><B>$text{'index_type'}</B></TD>\n";
  print "</TR>\n";

  for($i=0; $i<@{$_[0]}; $i++) {
    print "<TR $cb>\n";
    print "  <TD><A HREF=\"$_[0]->[$i]\">$_[1]->[$i]</A></TD>\n";
    print "  <TD>$_[2]->[$i]</TD>\n";
    print "</TR>\n";
  }

  print "</TABLE>\n";
}

