#!/usr/bin/perl

  require './bind8-lib.pl';
  require "../../guardiandigital-lib.pl";
  &ReadParse();


  %access = &get_module_acl();
  &can_edit_zone(\%access, $in{'origin'}) || &error($text{'recs_ecannot'});
  $access{'ro'} && &error($text{'master_ero'});

  &lock_file($config{'chroot'}.$in{'file'});
  @recs = &read_zone_file($in{'file'}, $in{'origin'});
  &error_setup($text{'edit_err'});

  ### get the old record if needed
  $r = $recs[$in{'num'}] if (defined($in{'num'}));


  ### ############################## ###########################################
  ### We want to delete this record. ###########################################
  ### ############################## ###########################################
  if ($in{'delete'}) {
    ### Delete the record
    &lock_file($config{'chroot'}.$r->{'file'});
    &delete_record($r->{'file'}, $r);
    &bump_soa_record($in{'file'}, \@recs);

    ### Update reverse
    ($orevconf, $orevfile, $orevrec) = &find_reverse($in{'oldvalue0'});
    if ($in{'rev'} && $orevrec && &can_edit_reverse($orevconf) &&
        $in{'oldname'} eq $orevrec->{'values'}->[0] &&
        $in{'oldvalue0'} eq &arpa_to_ip($orevrec->{'name'})) {
      &lock_file($config{'chroot'}.$orevrec->{'file'});
      &delete_record($orevrec->{'file'} , $orevrec);
      &lock_file($config{'chroot'}.$orevfile);
      @orrecs = &read_zone_file($orevfile, $orevconf->{'value'});
      &bump_soa_record($orevfile, \@orrecs);
    }
    
    ### Update forward
    ($ofwdconf, $ofwdfile, $ofwdrec) = &find_forward($in{'oldvalue0'});
    if ($in{'fwd'} && $ofwdrec && &can_edit_zone($ofwdconf->{'value'}) &&
        &arpa_to_ip($in{'oldname'}) eq $ofwdrec->{'values'}->[0] &&
        $in{'oldvalue0'} eq $ofwdrec->{'name'}) {
      &lock_file($config{'chroot'}.$ofwdrec->{'file'});
      &delete_record($ofwdrec->{'file'}, $ofwdrec);
      &lock_file($config{'chroot'}.$ofwdfile);
      @ofrecs = &read_zone_file($ofwdfile, $ofwdconf->{'value'});
      &bump_soa_record($ofwdfile, \@ofrecs);
    }

    &ReloadNamed();

    &redirect("edit_recs.cgi?index=$in{'index'}&type=$in{'type'}");
    &unlock_all_files();
    exit;
  }


  ### Parse inputs
  if (!$in{'ttl_def'}) {
    $in{'ttl'} =~ /^\d+[MHDW]?$/ || &error(&text('edit_ettl', $in{'ttl'}));
    $ttl = $in{'ttl'};
  }

  ### $vals = $in{'value0'};
  ### for($i=1; defined($in{"value$i"}); $i++) { $vals .= " ".$in{"value$i"}; }


  ### ################## #######################################################
  ### We have a pointer. #######################################################
  ### ################## #######################################################
  if ($in{'type'} eq "PTR") {
    $vals = $in{'value0'};
    for($i=1; defined($in{"value$i"}); $i++) { $vals .= " ".$in{"value$i"}; }

    ### Make sure we have a valid IP address.
    if (!&check_ipaddress($in{'name'})) {
      &PrintError("$in{'value0'} is an invalid IP address.");
      exit;
    }

    ### Make sure we have a hostname.
    if (!$in{'value0'}) {
      &PrintError("Please enter a hostname.");
      exit;
    }

    ### Make sure we have a valid hostname.
    if ($in{'value0'} !~ m/^[A-Za-z0-9\-\.]+$/) {
      &PrintError("$in{'value0'} is an invalid hostname.");
      exit;
    }


    $name = &ip_to_arpa($in{'name'});

    ### Add the trailing dot.
    if ($in{'value0'} !~ /\.$/) { $vals .= "."; }
  }


  else {
    ### some other kind of record

    ### ########################## #############################################
    ### We have an address record. #############################################
    ### ########################## #############################################
    if ($in{'type'} eq "A") {

      $origin = $in{'origin'};

      ### If a user enters a hostname, not a FQDN, so we append $origin.
      if ($in{'name'} =~ m/^[A-Za-z0-9\-]+$/) {
        $in{'name'} = $in{'name'} . "." . $in{'origin'};
      }

      ### If the name is not $hostname.$origin, tell the user.
      if ($in{'name'} !~ m/^[A-Za-z0-9\-]+\.$origin\.?$/) {
        &PrintError("$in{'name'} is an invalid name.");
        exit;
      }

      ### Make sure we have a valid IP address.
      if (!&check_ipaddress($in{'value0'})) {
        &PrintError("$in{'value0'} is an invalid IP address.");
        exit;
      }


      if (!$access{'multiple'}) {
        ### Is this address already in use? Search all domains
        ### to find out..
        $conf = &get_config();
        @zl = &find("zone", $conf);

        foreach $z (@zl) {
          $typed = &find("type", $z->{'members'}) || next;
          next if ($typed->{'value'} ne "master");
          next if ($z->{'value'} =~ /in-addr.arpa/i);
          $file = &find("file",
          $z->{'members'})->{'value'};
          @frecs = &read_zone_file($file, $z->{'value'});

          foreach $fr (@frecs) {
            if ($fr->{'type'} eq "A" && $fr->{'values'}->[0] eq $vals &&
                $fr->{'name'} ne $r->{'name'}) {
              &error(&text('edit_edupip', $vals));
            }
          }
        }

      }

      ### If they forget the trailing dot add it for them.
      if ($in{'name'} !~ m/\.$/)   { $in{'name'} .= "."; }

      ### All is good, so rebuild $vals.
      $vals = $in{'value0'};
      for($i=1; defined($in{"value$i"}); $i++) { $vals .= " ".$in{"value$i"}; }

      $name = $in{'name'};
    }

    ### ##################### ##################################################
    ### We have a nameserver. ##################################################
    ### ##################### ##################################################
    elsif ($in{'type'} eq "NS") {

      ### Check the domain name.
      if ($in{'name'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'value1'} is not a valid domain.");
        exit;
      }

      ### Check the name server.
      if ($in{'value0'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'value1'} is not a valid name server name.");
        exit;
      }

      ### If they forget the trailing dot add it for them.
      if ($in{'name'} !~ m/\.$/)   { $in{'name'} .= "."; }
      if ($in{'value0'} !~ m/\.$/) { $in{'value0'} .= "."; }

      ### All is good, so rebuild $vals.
      $vals = $in{'value0'};
      for($i=1; defined($in{"value$i"}); $i++) { $vals .= " ".$in{"value$i"}; }

      $name = $in{'name'};
    }

    ### ######################### ##############################################
    ### We have a canonical name. ##############################################
    ### ######################### ##############################################
    elsif ($in{'type'} eq "CNAME") {

      $origin = $in{'origin'};

      ### If a user enters a hostname, not a FQDN, so we append $origin.
      if ($in{'name'} =~ m/^[A-Za-z0-9\-]+$/) {
        $in{'name'} = $in{'name'} . "." . $in{'origin'};
      }

      ### If the name is not $hostname.$origin, tell the user.
      if ($in{'name'} !~ m/^[A-Za-z0-9\-]+\.$origin\.?$/) {
        &PrintError("$in{'name'} is an invalid name");
        exit;
      }


      ### Make sure a real name has been entered.
      if ($in{'value0'} eq "") {
        &PrintError("Please enter a valid alias target");
        exit;
      }

      ### Make sure this real name is valid.
      elsif ($in{'value0'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'value0'} is an invalid alias target");
        exit;
      }

      ### If they forget the trailing dot add it for them.
      if ($in{'name'} !~ m/\.$/)   { $in{'name'} .= "."; }
      if ($in{'value0'} !~ m/\.$/) { $in{'value0'} .= "."; }

      ### All is good, so rebuild $vals.
      $vals = $in{'value0'};
      for($i=1; defined($in{"value$i"}); $i++) { $vals .= " ".$in{"value$i"}; }

      $name = $in{'name'};
    }

    ### ######################### ##############################################
    ### We have a mail exchanger. ##############################################
    ### ######################### ##############################################
    elsif ($in{'type'} eq "MX") {

      ### Check the domain name.
      if ($in{'name'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'value1'} is not a valid domain.");
        exit;
      }

      ### Check the mail server.
      if ($in{'value1'} !~ m/^[A-Za-z0-9\-\.]+$/) {
        &PrintError("$in{'value1'} is not a valid mail server name.");
        exit;
      }

      ### Check the priority.
      if ($in{'value0'} !~ m/^[0-9]+$/) {
        &PrintError("Priority must be an integer.");
        exit;
      }

      ### If they forget the trailing dot add it for them.
      if ($in{'name'} !~ m/\.$/)   { $in{'name'} .= "."; }
      if ($in{'value1'} !~ m/\.$/) { $in{'value1'} .= "."; }

      ### All is good, so rebuild $vals.
      $vals = $in{'value0'};
      for($i=1; defined($in{"value$i"}); $i++) { $vals .= " ".$in{"value$i"}; }

      $name = $in{'name'};
    }

  }


  ### ############### ###
  ### Add new record. ###
  ### ############### ###
  if ($in{'new'}) {
    ### just adding a new record
    &create_record($in{'file'}, $name, $ttl, "IN", $in{'type'}, $vals);

    $r = { 'name' => $name, 'ttl' => $ttl, 'class' => 'IN',
           'type' => $in{'type'}, 'values' => [ split(/\s+/, $vals) ] };

    ($revconf, $revfile, $revrec) = &find_reverse($in{'value0'});

    if ($in{'rev'} && $revconf && !$revrec && &can_edit_reverse($revconf)) {
      ### Add a reverse record if we are the master for the reverse
      ### domain, and if there is not already a reverse record
      ### for the address.
      &lock_file($config{'chroot'}.$revfile);
      &create_record($revfile, &ip_to_arpa($in{'value0'}), $ttl, "IN", "PTR", 
                     $name);
      @rrecs = &read_zone_file($revfile, $revconf->{'value'});
      &bump_soa_record($revfile, \@rrecs);
    }

    ($fwdconf, $fwdfile, $fwdrec) = &find_forward($vals);
    if ($in{'fwd'} && $fwdconf && !$fwdrec &&
        &can_edit_zone($fwdconf->{'value'})) {
      ### Add a forward record if we are the master for the forward
      ### domain, and if there is not already an A record
      ### for the address
      &lock_file($config{'chroot'}.$fwdfile);
      &create_record($fwdfile, $vals, $ttl, "IN", "A", $in{'name'});
      @frecs = &read_zone_file($fwdfile, $fwdconf->{'value'});
      &bump_soa_record($fwdfile, \@frecs);
    }
  }
  else {
    ### updating an existing record
    &lock_file($config{'chroot'}.$r->{'file'});

    if ($in{'type'} eq "PTR") {
      &modify_record($r->{'file'}, $r, $name, $ttl, "IN", $in{'type'},$vals);
    }
    else {
      &modify_record($r->{'file'}, $r, $in{'name'}, $ttl, "IN", $in{'type'},$vals);
    }

    ($orevconf, $orevfile, $orevrec) = &find_reverse($in{'oldvalue0'});
    ($revconf, $revfile, $revrec) = &find_reverse($in{'value0'});

    if ($in{'rev'} && $orevrec && &can_edit_reverse($orevconf) &&
        $in{'oldname'} eq $orevrec->{'values'}->[0] &&
        $in{'oldvalue0'} eq &arpa_to_ip($orevrec->{'name'})) {
      ### Updating the reverse record. Either the name, address
      ### or both may have changed. Furthermore, the reverse record
      ### may now be in a different file!
      &lock_file($config{'chroot'}.$orevfile);
      &lock_file($config{'chroot'}.$revfile);
      @orrecs = &read_zone_file($orevfile, $orevconf->{'value'});
      @rrecs = &read_zone_file($revfile, $revconf->{'value'});

      if ($revconf eq $orevconf && &can_edit_reverse($revconf)) {
        ### old and new in the same file

        &modify_record($orevrec->{'file'} , $orevrec, 
                       &ip_to_arpa($in{'value0'}),
                       $orevrec->{'ttl'}, "IN", "PTR", $name);

        &bump_soa_record($orevfile, \@orrecs);
      }
      elsif ($revconf && &can_edit_reverse($revconf)) {
        ### old and new in different files
        &delete_record($orevrec->{'file'} , $orevrec);
        &create_record($revfile, &ip_to_arpa($in{'value0'}),
        $orevrec->{'ttl'}, "IN", "PTR", $name);
        &bump_soa_record($orevfile, \@orrecs);
        &bump_soa_record($revfile, \@rrecs);
      }
      else {
        ### we don't handle the new reverse domain.. lose the
        ### reverse record
        &delete_record($orevrec->{'file'}, $orevrec);
        &bump_soa_record($orevfile, \@orrecs);
      }
    }

    ($ofwdconf, $ofwdfile, $ofwdrec) = &find_forward($in{'oldvalue0'});
    ($fwdconf, $fwdfile, $fwdrec) = &find_forward($in{'value0'});

    if ($in{'fwd'} && $ofwdrec && &can_edit_zone($ofwdconf->{'value'}) &&
        &arpa_to_ip($in{'oldname'}) eq $ofwdrec->{'values'}->[0] &&
        $in{'oldvalue0'} eq $ofwdrec->{'name'}) {
      ### Updating the forward record
      &lock_file($config{'chroot'}.$ofwdfile);
      &lock_file($config{'chroot'}.$fwdfile);
      @ofrecs = &read_zone_file($ofwdfile, $ofwdconf->{'value'});
      @frecs = &read_zone_file($fwdfile, $fwdconf->{'value'});

      if ($fwdconf eq $ofwdconf && &can_edit_zone($fwdconf->{'value'})) {
        ### Old and new are in the same file
        &modify_record($ofwdrec->{'file'} , $ofwdrec, $vals,
        $ofwdrec->{'ttl'}, "IN", "A", $in{'name'});
        &bump_soa_record($ofwdfile, \@ofrecs);
      }
      elsif ($fwdconf && &can_edit_zone($fwdconf->{'value'})) {
        ### Old and new in different files
        &delete_record($ofwdrec->{'file'} , $ofwdrec);
        &create_record($fwdfile, $vals, $ofwdrec->{'ttl'}, "IN", "A", 
                       $in{'name'});
        &bump_soa_record($ofwdfile, \@ofrecs);
        &bump_soa_record($fwdfile, \@frecs);
      }
      else {
        ### lose the forward because it has been moved to
        ### a zone not handled by this server
        &delete_record($ofwdrec->{'file'} , $ofwdrec);
        &bump_soa_record($ofwdfile, \@ofrecs);
      }
    }
  }

  &bump_soa_record($in{'file'}, \@recs);
  &unlock_all_files();

  &ReloadNamed();

  &redirect("edit_recs.cgi?index=$in{'index'}&type=$in{'type'}");






sub valname {
  return $_[0] =~ /^[A-z0-9\-\.\*]+$/;
}

### can_edit_reverse(&zone)
sub can_edit_reverse {
  return $access{'reverse'} || &can_edit_zone(\%access, $_[0]->{'value'});
}

