#!/usr/bin/perl

  require './bind8-lib.pl';
  require "../../guardiandigital-lib.pl";
  &ReadParse();

  &error_setup($text{'master_err2'});
  %access = &get_module_acl();
  &can_edit_zone(\%access, $in{'origin'}) || &error($text{'master_ecannot'});
  $access{'ro'} && &error($text{'master_ero'});
  $access{'params'} || &error($text{'master_esoacannot'});


  #### Input validity checks.
  $in{'master'} =~ /^[A-z0-9\-\.]+$/ ||
        &PrintError("'$in{'master'}' is not a valid master server.");
  $in{'email'} =~ /^\S+$/ ||
        &PrintError("'$in{'email'}' is not a valid e-mail address.");
  $in{'refresh'} =~ /^\S+$/ ||
        &PrintError("'$in{'refresh'}' is not a valid refresh time.");
  $in{'retry'} =~ /^\S+$/ ||
        &PrintError("'$in{'retry'}' is not a valid transfer retry time.");
  $in{'expiry'} =~ /^\S+$/ ||
        &PrintError("'$in{'expiry'}' is not a valid expiry time.");
  $in{'minimum'} =~ /^\S+$/ ||
        &PrintError("'$in{'minimum'}' is not a valid default TTL.");

  ### Add the trailing dot if it it is not specified.
  if ($in{'master'} !~ m/\.$/) { $in{'master'} .= "."; }
  if ($in{'email'} =~ s/\@/\./) { $in{'email'} .= "."; }

  &lock_file($config{'chroot'}.$in{'file'});

  @recs = &read_zone_file($in{'file'}, $in{'origin'});
  $old = $recs[$in{'num'}];
  if ($config{'soa_style'} == 1 && $old->{'values'}->[2] =~ /^(\d{8})(\d\d)$/) {
    if ($1 eq &date_serial()) { $serial = sprintf "%d%2.2d", $1, $2+1; }
    else { $serial = &date_serial()."00"; }
  }
  else { $serial = $old->{'values'}->[2]+1; }

  $vals = "$in{'master'} $in{'email'} (\n" . "\t\t\t$serial\n" .
          "\t\t\t$in{'refresh'}\n" . "\t\t\t$in{'retry'}\n" .
	  "\t\t\t$in{'expiry'}\n" . "\t\t\t$in{'minimum'} )";

  &modify_record($in{'file'}, $old, $old->{'name'}, $old->{'ttl'},
                 $old->{'class'}, "SOA", $vals);

  &unlock_file($config{'chroot'}.$in{'file'});

  &RestartNamed();

  ### Go back to index page.
  &redirect("edit_master.cgi?index=$in{'index'}");

