#!/usr/bin/perl

  require './bind8-lib.pl';
  &ReadParse();

  %access = &get_module_acl();
  $access{'defaults'} || &error($text{'forwarding_ecannot'});
  &error_setup($text{'forwarding_err'});



  ### ########## ###############################################################
  ### Forwarding ###############################################################
  ### ########## ###############################################################
  ### Disable the "forward only;" directive if we have no forwarders.
  if (!$in{'forwarders'}) { $in{'forward'} = ""; }

  &lock_file($config{'chroot'}.$config{'named_conf'});
    $conf = &get_config();
    $options = &find("options", $conf);
    &save_address('forwarders', $options, 1);
    &save_choice('forward', $options, 1);
    &flush_file_lines();
  &unlock_file($config{'chroot'}.$config{'named_conf'});



  ### ############# ############################################################
  ### Zone Defaults ############################################################
  ### ############# ############################################################
  &lock_file($config{'chroot'}.$config{'named_conf'});
  &lock_file("$module_config_directory/zonedef");

  $conf = &get_config();
  $options = &find("options", $conf);


  ### If have "Allow None" checked, then put 'none' in named.conf.
  if ($in{'allow-transfer_def'}) {
    $in{'allow-transfer_def'} = 0;
    $in{'allow-transfer'} = "none";
  }

  ### If have "Allow Any" checked, then put 'any' in named.conf.
  if ($in{'allow-query_def'}) {
    $in{'allow-query_def'} = 0;
    $in{'allow-query'} = "any";
  }


#  foreach $c ("master", "slave", "response") {
#    if ($in{$c}) {
#      push(@check, { 'name' => 'check-names', 'values' => [ $c, $in{$c} ] });
#    }
#  }
#  &save_directive($options, 'check-names', \@check, 1);
#  &save_choice("notify", $options, 1);


  &save_addr_match("allow-transfer", $options, 1);
  &save_addr_match("allow-query", $options, 1);

  $in{'refresh'} =~ /^\S+$/ || &error(&text('master_erefresh', $in{'refresh'}));
  $in{'retry'} =~ /^\S+$/   || &error(&text('master_eretry', $in{'retry'}));
  $in{'expiry'} =~ /^\S+$/  || &error(&text('master_eexpiry', $in{'expiry'}));
  $in{'minimum'} =~ /^\S+$/ || &error(&text('master_eminimum', $in{'minimum'}));

  %zonedef = ( 'refresh', $in{'refresh'}, 'retry', $in{'retry'},
               'expiry', $in{'expiry'}, 'minimum', $in{'minimum'} );


  &lock_file("$module_config_directory/config");
  foreach $k (keys %config) { delete($config{$k}) if ($k =~ /^tmpl_/); }

  $j=0;
  for($i=0; defined($in{"name_$i"}); $i++) {
    next if (!$in{"name_$i"});
    $in{"type_$i"} eq 'A' || !$in{"def_$i"} || &error($text{'master_eiptmpl'});
    $config{"tmpl_$j"} = join(' ', $in{"name_$i"}, $in{"type_$i"},
                              $in{"def_$i"} ? () : ( $in{"value_$i"} ) );
    $j++;
  }

  &write_file("$module_config_directory/config", \%config);
  &unlock_file("$module_config_directory/config");

  &save_zone_defaults(\%zonedef);
  &flush_file_lines();

  &unlock_file($config{'chroot'}.$config{'named_conf'});
  &unlock_file("$module_config_directory/zonedef");

  &RestartNamed();

  &redirect("");





sub check_mins { return $_[0] =~ /^\d+$/ ? undef : $text{'forwarding_emins'}; }
sub check_trans {return $_[0] =~ /^\d+$/ ? undef : $text{'forwarding_etrans'};}
