#!/usr/bin/perl

  require 'net-lib.pl';
  &ReadParse();

  ### Get boot interfaces's again
  @boot = &boot_interfaces();

  if ($in{'new'}) { $b->{'new'} = 1; }

  ### ############################### ###
  ### We want to delete an interface. ###
  ### ############################### ###
  if ($in{'delete'}) {
    ### Delete interface
    &error_setup($text{'bifc_err1'});
    $b = $boot[$in{'idx'}];


    $out = `ifconfig $b->{'name'} 0 2>&1`;
    &delete_interface($in{'idx'});

    ### Clean and save the environment.
    my %ENV_RESTORE;
    %ENV_RESTORE  =  &clean_env();

      ### Restart networking.
      $out = `/etc/init.d/network restart`;

    ### Restore the environment.
    &restore_env(%ENV_RESTORE);
  }

  ### ######################################### ###
  ### We want to create or update an interface. ###
  ### ######################################### ###
  else {
    ### Save or create interface
    &error_setup($text{'bifc_err2'});


    if (!$in{'new'}) {
      $oldb = $boot[$in{'idx'}];
      $b->{'index'} = $in{'idx'};
      $b->{'name'} = $oldb->{'name'};
      $b->{'virtual'} = $oldb->{'virtual'}
        if (defined($oldb->{'virtual'}));
    }
    elsif (defined($in{'virtual'})) {
      ### creating a virtual interface
      if ($in{'virtual'} !~ /^\d+$/) {
          &PrintError("Please enter a virtual interface identifier");
      }

      foreach $eb (@boot) {
        if ($eb->{'name'} eq "$in{'name'}:$in{'virtual'}") {
          &PrintError("The virtual interface $in{'name'}:$in{'virtual'} already exists");
        }
      }

      ### Format the interface name in :' virtual interface form.
      $b->{'name'} = "$in{'name'}:$in{'virtual'}";

    }
    elsif ($in{'name'} =~ /^([a-z0-9]+):(\d+)$/) {
      ### also creating a virtual interface
      foreach $eb (@boot) {
        if ($eb->{'name'} eq $1 && $eb->{'virtual'} eq $2) {
          &error(&text('bifc_evirtdup', $in{'name'}));
        }
      }

      ### Format the interface name in :' virtual interface form.
      $b->{'name'} = "$1:$2";
    }
    elsif ($in{'name'} =~/^[a-z]+\d+$/) {
      ### creating a real interface
      foreach $eb (@acts) {
        if ($eb->{'name'} eq $in{'name'}) {
          &error(&text('bifc_edup', $in{'name'}));
        }
      }

      $b->{'name'} = $in{'name'};
    }
    else { &PrintError("'$in{'name'}' is not a valid interface name."); }


    ### Now let's populate.
    if ($in{'mode'} eq 'dhcp' || $in{'mode'} eq 'bootp') {
      $b->{$in{'mode'}}++;
      $auto++;
    }
    else {
      &valid_boot_address($in{'address'}) ||
       &PrintError("'$in{'address'}' is not a valid IP address.");
      $b->{'address'} = $in{'address'};
    }

    ### Set netmask.
    if (&can_edit("netmask", $b)) {
      $auto && !$in{'netmask'} || &check_ipaddress($in{'netmask'}) ||
         &PrintError("'$in{'netmask'}' is not a valid netmask.");
      $b->{'netmask'} = $in{'netmask'};
    }

    ### Set broadcast.
    if (&can_edit("broadcast", $b)) {
      $out = `/bin/ipcalc --broadcast $in{'address'} $in{'netmask'}`;
      ($b->{'broadcast'}) = ($out =~ m/^BROADCAST\=(.*)$/);
    }

    ### Set MTU.
    if (&can_edit("mtu", $b)) {
      $in{'mtu'} =~ /^\d+$/ || &error(&text('bifc_emtu', $in{'mtu'}));
      $b->{'mtu'} = $in{'mtu'};
    }

    if ($in{'up'} && &can_edit("up", $b)) { $b->{'up'}++; }

    $b->{'fullname'} = $b->{'name'}.
      ($b->{'virtual'} eq '' ? '' : ':'.$b->{'virtual'});



    ### Save it!
    &save_interface($b);


    if ($in{'activate'}) {
      ### Make this interface active (if possible)
      &error_setup($text{'bifc_err3'});
      $b->{'up'}++;
      $b->{'address'} = &to_ipaddress($b->{'address'});
      &activate_interface($b);
    }

    ### Clean and save the environment.
    my %ENV_RESTORE;
    %ENV_RESTORE  =  &clean_env();

      ### Restart networking.
      `/etc/init.d/network restart`;

    ### Restore the environment.
    &restore_env(%ENV_RESTORE);

  }


  &redirect("");

