#!/usr/bin/perl

  require "postfix-lib.pl";
  require "../../guardiandigital-lib.pl";
  &ReadParse();

  ### Get out our inputs.
  $domain = $in{'domain'};
  $defrec = $in{'defrec'};


  ### ERROR CHECKING ###
  ### Make sure we have a domain and a default recipient.
  if (!$domain)    { &PrintError("Please enter a domain."); exit; }
  elsif (!$defrec) { &PrintError("Please enter a default recipient."); exit; }

  ### Make sure our domain is valid.
  elsif ($domain !~ m/^[A-Za-z0-9\-\.]+\.[A-Za-z]+$/) {
    &PrintError("$domain is an invalid domain.");
    exit;
  }

  ### Make sure our default recipient is valid.
  elsif ($defrec =~ m/.*@.*@.*/) {
    &PrintError("$defrec is an invalid default recipient.");
    exit;
  }



  if (($defrec =~ m/^[A-Za-z0-9]+$/) ||
      ($defrec =~ m/^[A-Za-z0-9]+@[A-Za-z0-9\-\.]+\.[A-Za-z]+$/)) {

    ### Add the domain to the virtusertable.
    &add_domain($domain, $defrec);

    ### Regenerate our database file.
    &regenerate_virtual_table();

    ### Reload postfix so the changes take effect immediately.
    &reload_postfix();

  }
  else { &PrintError("$defrec is an invalid default recipient."); exit;}


  ### Go away.
  &redirect("domains.cgi");
