#!/usr/bin/perl

  require "postfix-lib.pl";
  require "../../guardiandigital-lib.pl";
  &ReadParse();

  ### Get out our inputs.
  $index  = $in{'index'};
  $domain = $in{'domain'};
  $source = $in{'source'};
  $dest   = $in{'dest'};

#print "Content-type: text/html\n\n<PRE>\n\n";
#print "index  = $index\n";
#print "domain = $domain\n";
#print "source = $source\n";
#print "dest   = $dest\n";
#exit;




  ### ########################### ###
  ### We want to delete an entry. ###
  ### ########################### ###
  if ($in{'delete'}) { &save_mapping(0, $domain, $index, $source, $dest); }


  ### ########################### ###
  ### We want to add a new entry. ###
  ### ########################### ###
  elsif ($in{'new'})  {

    ### Check validity of source and destination addresses.
    if ($source =~ m/^[A-Za-z0-9\.\-]+$/) {
      if (($dest =~ m/^[A-Za-z0-9\-\.]+$/) ||
          ($dest =~ m/^[A-Za-z0-9\-\.]+@[A-Za-z0-9\-\.]+\.[A-Za-z]+$/)) {
        &save_mapping(2, $domain, $index, "$source\@$domain", $dest);
      }
      else { &PrintError("$dest is an invalid recipient."); exit; }
    }
    else { &PrintError("$source is an invalid e-mail username."); }

  }

  ### ########################### ###
  ### We want to update an entry. ###
  ### ########################### ###
  elsif ($in{'save'}) {

    if (!$in{'defaultrec'}) {
      if ($source !~ m/^[A-Za-z0-9\.\-]+\@$domain$/) {
        &PrintError("$source is an invalid e-mail adddress.  It must be user\@$domain.");
        exit;
      }
      else {
        if (($dest =~ m/^[A-Za-z0-9\-\.]+$/) ||
            ($dest =~ m/^[A-Za-z0-9\-\.]+@[A-Za-z0-9\-\.]+\.[A-Za-z]+$/)) {
          &save_mapping(1, $domain, $index, $source, $dest);
        }
        else { &PrintError("$dest is an invalid recipient."); exit; }
      }
    }

    else {
      if (($dest =~ m/^[A-Za-z0-9\-\.]+$/) ||
          ($dest =~ m/^[A-Za-z0-9\-\.]+@[A-Za-z0-9\-\.]+\.[A-Za-z]+$/)) {
        &save_mapping(1, $domain, $index, $source, $dest);
      } else {
        &PrintError("$dest is an invalid e-mail adddress.");
        exit;
      }
    }

  }


  ### Regenerate our database file.
  &regenerate_virtual_table();

  ### Reload postfix so the changes take effect immediately.
  &reload_postfix();

  ### Go away.
  &redirect("edit_domain.cgi?domain=$domain");
