#!/usr/bin/perl

  ### Include the standard library and define local variables.
  require './sshd-lib.pl';
  my ($key, $value);

  ### Print the header and a horizonal rule.
  &header($text{'index_title'}, "", undef, 0, 1);

  ### Now let's parse the config file and store in local vars.
  open SSHDCONFIG, $config{'sshd_config'};
    while (<SSHDCONFIG>) {
      chomp($_);
      if (($_ !~ m/^#/) && ($_ ne "")) { 
        ($key, $value) = split /\ /, $_, 2;

        $$key = $value;
      }
    }
  close;

  $AllowUsers_help  = &hlink("Allow Users", "AllowUsers");
  $AllowUsers_ucb   = &user_chooser_button("AllowUsers", 1, 0);

  $AllowGroups_help  = &hlink("Allow Groups", "AllowGroups");
  $AllowGroups_ucb   = &group_chooser_button("AllowGroups", 1, 0);

  $DenyUsers_help   = &hlink("Deny Users", "DenyUsers");
  $DenyUsers_ucb    = &user_chooser_button("DenyUsers", 1, 0);

  $DenyGroups_help  = &hlink("Deny Groups", "DenyGroups");
  $DenyGroups_ucb   = &group_chooser_button("DenyGroups", 1, 0);


print <<EOF01;

<FORM ACTION="write_configfile.cgi" METHOD="POST">
<CENTER><TABLE BORDER=0 WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR $tb>
    <TD COLSPAN=2><DIV CLASS=ttitle><B>Secure Shell Management</B></DIV></TD>
  </TR>

  <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>
      <TR $tb>
        <TD COLSPAN=2><DIV CLASS=thead><B>Server Configuration</TD>
      </TR>
  
      <TR $cb>
        <TD COLSPAN=2><DIV CLASS=nbody>
          Below you can define specific users or groups that you wish to allow
          or deny access to.  If the box is left blank the access will be
          granted to all users, provided the appropriate access control rules
          are defined in the <B>Security</B> module.

          <P>Keep in mind that if you grant access to a specific user or group
          then <B>only</B> those users will be able to ssh to the machine.  Be
          careful not to lock yourself out.  These should only be modified if
          you know what you are doing!
        </DIV></TD>
      </TR>

      <TR $cb> <TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $tb>
        <TD WIDTH="40%">
          <!-- BEGIN HIDDEN default values -->
          <INPUT TYPE="HIDDEN" NAME="Port" VALUE="22">
          <INPUT TYPE="HIDDEN" NAME="PasswordAuthentication" VALUE="no">
          <INPUT TYPE="HIDDEN" NAME="RhostsAuthentication" VALUE="no">
          <INPUT TYPE="HIDDEN" NAME="RhostsRSAAuthentication" VALUE="no">
          <INPUT TYPE="HIDDEN" NAME="RSAAuthentication" VALUE="yes">
          <INPUT TYPE="HIDDEN" NAME="StrictModes" VALUE="yes">
          <!-- END HIDDEN default values -->
          <DIV CLASS="thead"><B>Keyword</B>
        </TD>
        <TD WIDTH="60%"><DIV CLASS="thead"><B>Value</B></TD>
  </TR>


  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$AllowGroups_help</A></TD>
    <TD><DIV CLASS="tbody">
      <INPUT TYPE="TEXT" NAME="AllowGroups" SIZE="40" VALUE="$AllowGroups">
      $AllowGroups_ucb
    </TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$AllowUsers_help</A></TD>
    <TD><DIV CLASS="tbody">
      <INPUT TYPE="TEXT" NAME="AllowUsers" SIZE="40" VALUE="$AllowUsers">
      $AllowUsers_ucb
    </TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$DenyGroups_help</A></TD>
    <TD><DIV CLASS="tbody">
      <INPUT TYPE="TEXT" NAME="DenyGroups" SIZE="40" VALUE="$DenyGroups">
      $DenyGroups_ucb
    </TD>
  </TR>

  <TR $cb>
    <TD><DIV CLASS="nbody"><B>$DenyUsers_help</A></TD>
    <TD><DIV CLASS="tbody">
      <INPUT TYPE="TEXT" NAME="DenyUsers" SIZE="40" VALUE="$DenyUsers">
      $DenyUsers_ucb
    </TD>
  </TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $cb>
    <TD COLSPAN="2" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Write Configuration">
    </TD>
  </TR>
</TABLE>
</TABLE>
</FORM>
</CENTER>
EOF01



&ryanFooter();

