### ############################################################################
### sshd-lib.pl
### Subroutines for use with the SSHD Webmin module.
###
### Ryan W. Maple <ryan@guardiandigital.com>
### Guardian Digital, Inc.
### ############################################################################

  ### Include the general subroutines from web-lib.pl and do init_config().
  do '/usr/webtool/web-lib.pl';
  &init_config();


  ### ###############################################################
  ### PrintError()
  ### ###############################################################
  ### Used to pop up a JavaScript with a $message then return user to 
  ### previous page.
  ### ###############################################################

  sub PrintError {
    my ($message) = @_;

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go(-1);
  </SCRIPT>
</HEAD>
</HTML>  
ErrorEOF
  }

  ### ###############################################################
  ### DaemonStatus()
  ### ###############################################################
  ### Return the status of the daemon.
  ### ###############################################################

  sub DaemonStatus {
    $status = `/bin/netstat --inet -a -n`;

    if ($status =~ m/\:22\s+.*LISTEN/) {
      return 1;
    }
    else {
      return 0;
    }
  }


  ### ###############################################################
  ### ValidUser();
  ### ###############################################################
  ### See if user exists on system.
  ### ###############################################################

  sub ValidUser {
    my ($username, $isValid);

    ($username) = @_;
    $isValid = 0;

    &obtain_lock("/etc/passwd");
    open PASSWD, "/etc/passwd";
      while (<PASSWD>) { if ($_ =~ m/^$username\:/) { $isValid = 1; } }
    close PASSWD;
    &release_lock("/etc/passwd");

    return $isValid;
  }






  ### ####################################################
  ### Return one like a good little library *pat on head*.
  ### ####################################################
  1;

