#!/usr/bin/perl

  ### ###################################################
  ### Include the standard library and decode form input.
  ### ###################################################
  require './sshd-lib.pl';
  &ReadParse();


  ### Read in the configuration file.
  $lref = &read_file_lines("/etc/ssh/sshd_config");

    ### Go through each line of the file and update the directives we want set.
    foreach $line (@$lref) {
      if ($in{'AllowUsers'} && ($line =~ m/^AllowUsers\ /)) {
        $set_AllowUsers = 1;
        $line = "AllowUsers $in{'AllowUsers'}";
      }
      elsif ($line =~ m/^AllowUsers\ /) { $line = ""; }

      if ($in{'DenyUsers'} && ($line =~ m/^DenyUsers\ /)) {
        $set_DenyUsers = 1;
        $line = "DenyUsers $in{'DenyUsers'}";
      }
      elsif ($line =~ m/^DenyUsers\ /) { $line = ""; }

      if ($in{'AllowGroups'} && ($line =~ m/^AllowGroups\ /)) {
        $set_AllowGroups = 1;
        $line = "AllowGroups $in{'AllowGroups'}";
      }
      elsif ($line =~ m/^AllowGroups\ /) { $line = ""; }

      if ($in{'DenyGroups'} && ($line =~ m/^DenyGroups\ /)) {
        $set_DenyGroups = 1;
        $line = "DenyGroups $in{'DenyGroups'}";
      }
      elsif ($line =~ m/^DenyGroups\ /) { $line = ""; }

    }


    ### If the directive is not present, and we want to set, then append it.
    if (!$set_AllowUsers && $in{'AllowUsers'})
      { push @$lref, "AllowUsers $in{'AllowUsers'}"; }
  
    if (!$set_AllowGroups && $in{'AllowGroups'})
      { push @$lref, "AllowGroups $in{'AllowGroups'}"; }
  
    if (!$set_DenyUsers && $in{'DenyUsers'})
      { push @$lref, "DenyUsers $in{'DenyUsers'}"; }
  
    if (!$set_DenyGroups && $in{'DenyGroups'})
      { push @$lref, "DenyGroups $in{'DenyGroups'}"; }

  ### Write the file back to disk.
  &flush_file_lines;

  ### Clean and save the environment.
  my %ENV_RESTORE;
  %ENV_RESTORE  =  &clean_env();

    ### Restart the daemon.
    `/etc/init.d/sshd restart`;
    sleep 1;

  ### Restore the environment.
  &restore_env(%ENV_RESTORE);


  ### Your hands and feet are mangos... you're gonna be a genius anywayayay!
  &redirect("");

