#!/usr/bin/perl

  require "time-lib.pl";

  local $rawdate, $rawhwdate, %system_date, $rawtime, %hw_date, $txt = "";

  ### Error cases.
  if( $access{ 'sysdate' } && $access{ 'hwdate' } ) {
     &error( $text{ 'acl_error' } );
  }

  if( !$access{ 'sysdate' } && !&has_command( "date" ) ) {
    &error( &text( 'error_cnf', "<tt>date</tt>" ) );
  }

  if( !$access{ 'hwdate' } && !&has_command( "hwclock" ) ) {
    &error( &text( 'error_cnf', "<tt>hwclock</tt>" ) );
  }


  ### Print header
  &header( $text{ 'index_title' }, "", "index", 1, 1, undef );

  ### If we have access to, then print the page out.
  if( !$access{ 'sysdate' } ) {
    print <<EOF99;
<P><FORM ACTION="apply.cgi" METHOD="POST">
<BR><CENTER><TABLE BORDER="0" WIDTH="620" CELLSPACING="0" CELLPADDING="0">
  <TR $tb><TD>
    <DIV CLASS=ttitle><B>System Time</B></DIV>
  </TD></TR>

  <TR $cb><TD><DIV CLASS=nbody>
    This section allows you to set the system time.  By clicking "Set System Time" you will set the system clock, along with the hardware clock.
  </TD></TR>

  <TR $cb><TD>&nbsp;</TD></TR>
</TABLE></CENTER>
EOF99

  $rawdate = `date`;
  chop( $rawdate );
  $rawdate =~ s/ {1,}/ /g;

  ### Store date information in appropriate variables.
  ( $system_date{ 'day' }, $system_date{ 'month' }, $system_date{ 'date' }, 
    $rawtime, $_, $system_date{ 'year' } ) = split( / /, $rawdate );

  ### Store time information in appropriate variables.
  ( $system_date{ 'hour' }, $system_date{ 'minute' }, 
    $system_date{ 'second' } ) = split( /:/, $rawtime );



  &tabletime("<DIV CLASS=thead><B>$text{'sys_title'}", %system_date );

  print <<EOF98;
  <CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING=0 CELLSPACING=0>
  <TR><TD $cb ALIGN=RIGHT><DIV CLASS=nbody>
    <input type=submit name=action value="$text{ 'action_apply' }">
  </TD></TR>
  </TABLE></CENTER></FORM>


  <FORM ACTION="ntp.cgi" METHOD="POST">
<BR><CENTER><TABLE BORDER="0" WIDTH="620" CELLSPACING="0" CELLPADDING="0">
  <TR $tb> <TD COLSPAN="3">
    <DIV CLASS=thead><B>Setup Time Servers</B></DIV>
  </TD> </TR>

  <TR $cb><TD COLSPAN=3><DIV CLASS=nbody>
    This section allows you to setup which servers you would like to use as
    time servers.  For more information on this, please visit
    <A HREF="http://www.ntp.org" TARGET="_ntpwin">http://www.ntp.org</A>. 
    Your system will sync itself with these systems often, using the three
    servers to assure accuracy.  Your current time servers are listed below
    the text boxes.

    <P>A list of servers can be found
    <A HREF="http://www.eecis.udel.edu/~mills/ntp/clock1.htm" TARGET="_ntp">
    here.</A>  Please find the three geographically closest to you and enter
    them in the text boxes below.  (Note:  These should be hostnames,
    <B>not</B> IP addresses.)

    <P>Please note that if you only have two servers, you can re-enter the same
    server into the "Server Three".  You must, however, have at least two
    different servers.
  </TD></TR>

  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>


  <TR $cb>
   <TD><DIV CLASS=nbody><B>Server One</B></TD>
   <TD><DIV CLASS=nbody><B>Server Two</B></TD>
   <TD><DIV CLASS=nbody><B>Server Three</B></TD>
  </TR>

  <TR $cb>
   <TD><DIV CLASS=tbody> <INPUT TYPE="TEXT" NAME="xntpd01" WIDTH="30"> </TD>
   <TD><DIV CLASS=tbody> <INPUT TYPE="TEXT" NAME="xntpd02" WIDTH="30"> </TD>
   <TD><DIV CLASS=tbody> <INPUT TYPE="TEXT" NAME="xntpd03" WIDTH="30"> </TD>
  </TR>

EOF98

  @hosts = &get_current_ntphosts();
  print "  <TR $cb>\n";
  print "   <TD><DIV CLASS=nbody> <B>$hosts[0]</B> </TD>\n"; 
  print "   <TD><DIV CLASS=nbody> <B>$hosts[1]</B> </TD>\n"; 
  print "   <TD><DIV CLASS=nbody> <B>$hosts[2]</B> </TD>\n"; 
  print "  </TR>\n";

print <<EOF97;
  <TR $cb> <TD COLSPAN=3>&nbsp;</TD> </TR>

  <TR $cb>
    <TD COLSPAN="3" ALIGN="RIGHT"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" VALUE="Setup Servers">
    </TD>
  </TR>
  </TABLE></CENTER></FORM>
EOF97
  }

  &ryanFooter("/SystemManager/");


### Local subroutines.
sub get_current_ntphosts() {
  local ($host1, $host2, $host3);

  &obtain_lock("/etc/ntp.conf");
  open CONF, "/etc/ntp.conf";
    while (<CONF>) { if ($_ =~ m/^server\ (.*)$/) { push @ntphosts, $1; } }
  close CONF;
  &release_lock("/etc/ntp.conf");


  return @ntphosts;
}


sub tabletime {
  my ( $label, %src ) = @_,

  %assoc_day = ( "Mon", $text{ 'day_1' }, "Tue", $text{ 'day_2' }, 
                 "Wed", $text{ 'day_3' }, "Thu", $text{ 'day_4' }, 
                 "Fri", $text{ 'day_5' }, "Sat", $text{ 'day_6' }, 
                 "Sun", $text{ 'day_7' } ),

  %assoc_month = ( "Jan", $text{ 'month_1' }, "Feb", $text{ 'month_2' }, 
                   "Mar", $text{ 'month_3' }, "Apr", $text{ 'month_4' }, 
                   "May", $text{ 'month_5' }, "Jun", $text{ 'month_6' }, 
                   "Jul", $text{ 'month_7' }, "Aug", $text{ 'month_8' }, 
                   "Sep", $text{ 'month_9' }, "Oct", $text{ 'month_10' }, 
                   "Nov", $text{ 'month_11' }, "Dec", $text{ 'month_12' } );

print <<EOF70;
  <CENTER><table nosave border=0 width="620" cellpadding=0 cellspacing=0>
  <tr $tb><td>$label</td></tr>
  </table></CENTER>

  <CENTER><table nosave border=0 width="620" cellpadding=0 cellspacing=0>
  <tr $cb>
    <td nosave><DIV CLASS=nbody><b>$text{'day'}</b></td>
    <td nosave><DIV CLASS=nbody><b>$text{'date'}</b></td>
    <td nosave><DIV CLASS=nbody><b>$text{'month'}</b></td>
    <td nosave><DIV CLASS=nbody><b>$text{'year'}</b></td>
    <td><DIV CLASS=nbody><b>$text{'hour'}</b></td>
  </tr>

  <tr $cb>
    <td><DIV CLASS=nbody>$assoc_day{ $src{'day'} }</td>
    <td><DIV CLASS=nbody>
EOF70
      print &p_select( "date", $src{ 'date' }, ( 1..31 ) );
print <<EOF71;
    </td>
    <td><DIV CLASS=nbody>
EOF71
      print &p_select_wdl( "month", $assoc_month{ $src{'month'} }, 
                           "01",( $text{'month_1'}, "02", $text{'month_2'},
                           "03", $text{'month_3'}, "04", $text{'month_4'},
                           "05", $text{'month_5'}, "06", $text{'month_6'},
                           "07", $text{'month_7'}, "08", $text{'month_8'},
                           "09", $text{'month_9'}, "10", $text{'month_10'},
                           "11", $text{'month_11'}, "12", $text{'month_12'}
                         ) );
    print "</td>\n";
    print "<td><DIV CLASS=nbody>\n";

      print &p_select( "year", $src{ 'year' }, ( 1969..2037 ) );

    print "</td>\n";
    print "<td><DIV CLASS=nbody>\n";

      print &p_select( "hour", $src{ 'hour' }, ( "00", "01", "02", "03", "04",
                                                 "05", "06", "07", "08", "09",
                                                 10..23 ));
      print ":";
      print &p_select( "minute", $src{ 'minute' }, ( "00", "01", "02", "03", 
                                                     "04", "05", "06", "07", 
                                                     "08", "09", 10..59) );
      print ":";
      print &p_select( "second", $src{ 'second' }, ( "00", "01", "02", "03",
                                                     "04", "05", "06", "07",
                                                     "08", "09", 10..59 ) );
    print "</td>\n";
    print "</tr>\n";
  print "</table></CENTER>\n";
}
