#!/usr/bin/perl

  require "./time-lib.pl";
  require "/usr/webtool/guardiandigital-lib.pl";
  &ReadParse();

  my ($server1name, $server2name, $server3name);
  my ($server1ip, $server2ip, $server3ip);

  ### Read in the hostnames.
  $server1name = $in{'xntpd01'};
  $server2name = $in{'xntpd02'};
  $server3name = $in{'xntpd03'};

  ### Resolve to IP addresses.
  $server1ip = &to_ipaddress($server1name);
  $server2ip = &to_ipaddress($server2name);
  $server3ip = &to_ipaddress($server3name);

  ### Make sure three are entered.
  if (!$server1name || !$server2name || !$server3name) {
    &error("Please enter all three hostnames.");
  }

  ### Make sure all three are valid hostnames (they resolve).
  if (!$server1ip) {
    &PrintError("$server1name is not a valid hostname.  Please re-enter");
    exit;
  }
  elsif (!$server2ip) {
    &PrintError("$server2name is not a valid hostname.  Please re-enter");
    exit;
  }
  elsif (!$server3ip) {
    &PrintError("$server3name is not a valid hostname.  Please re-enter");
    exit;
  }


  ### #############
  ### /etc/ntp.conf
  ### #############

  ### Read into @conf;
  &obtain_lock("/etc/ntp.conf");
  open CONF, "/etc/ntp.conf";
    while (<CONF>) { chomp $_; if ($_ !~ m/^server/) { push @conf, $_; } }
  close CONF;

  ### Write it back, with our servers on the top.
  open CONF, ">/etc/ntp.conf";
    print CONF "server $server1name\n";
    print CONF "server $server2name\n";
    print CONF "server $server3name\n";
    foreach (@conf) { print CONF "$_\n"; }
  close CONF; 
  &release_lock("/etc/ntp.conf");


  ### #####################
  ### /etc/ntp/step-tickers
  ### #####################

  ### Just re-write the file from scratch, since this is all that is in there.
  &obtain_lock("/etc/ntp/step-tickers");
  open TICKERS, ">/etc/ntp/step-tickers";
    print TICKERS "$server1ip\n";
    print TICKERS "$server2ip\n";
    print TICKERS "$server3ip\n";
  close TICKERS;
  &release_lock("/etc/ntp/step-tickers");

  ### Sanitize file permissions.
  chmod 0600, "/etc/ntp/step-tickers";
  chmod 0640, "/etc/ntp.conf";

  ### Clean and save the environment.
  my %ENV_RESTORE;
  %ENV_RESTORE  =  &clean_env();

    ### Restart the daemon.
    `/etc/init.d/xntpd restart`;

  ### Restore the environment.
  &restore_env(%ENV_RESTORE);


  ### ###############################
  ### All done, go back to main page.
  ### ###############################
  redirect("/SystemManager/time");

