# custom-lib.pl
# Functions for storing custom commands

  do '/usr/webtool/web-lib.pl';
  &init_config();

  ### ###############################################################
  ### create_user(user, pass, shell, name);
  ### ###############################################################
  ### Creates a new user.
  ### ###############################################################

  sub create_user {
    $PASSWD = "/etc/passwd";
    $SHADOW = "/etc/shadow";
    $GROUP  = "/etc/group";

    ### Get the variables that were passed, creation date, uid, and gid.
    ($user, $pass, $shell, $name) = @_;
    $sp_lstchg = int(time() / (60*60*24));
    $uid = &GetNextUID();
    ### $gid = &GetNextGID();
    $gid = 110;			### Put user in group 'admin' by default.


    ### Read in passwd, shadow, and group files.
    open PASSWD, "$PASSWD"; @P_FILE = <PASSWD>; close PASSWD;
    open SHADOW, "$SHADOW"; @S_FILE = <SHADOW>; close SHADOW;
### open GROUP, "$GROUP"; @G_FILE = <GROUP>; close GROUP;


    ### Update password array.
    push @P_FILE, "$user:x:$uid:$gid:$name:/home/$user:$shell\n";

    ### Update shadow array.
    push @S_FILE, "$user:$pass:$sp_lstchg:0:99999:7:-1:-1:\n";

    ### Update group array.
### push @G_FILE, "$user:x:$gid:\n";


    ### Write the updated passwd file.
    $output = `/bin/cp -u $PASSWD $PASSWD.bak`;
    &obtain_lock($PASSWD);
    open PASSWD, ">$PASSWD";
      foreach (@P_FILE) { print PASSWD $_; }
    close PASSWD;
    &release_lock($PASSWD);


    ### Write the updated shadow file.
    $output = `/bin/cp -u $SHADOW $SHADOW.bak`;
    &obtain_lock($SHADOW);
    open SHADOW, ">$SHADOW";
      foreach (@S_FILE) { print SHADOW $_; }
    close SHADOW;
    &release_lock($SHADOW);


    ### Write the updated group file.
### $output = `/bin/cp -u $GROUP $GROUP.bak`;
### &obtain_lock($GROUP);
### open GROUP, ">$GROUP";
###   foreach (@G_FILE) { print GROUP $_; }
### close GROUP;
### &release_lock($GROUP);


    ### Setup home directory.
    $output = `/bin/cp -r /etc/skel /home/$user`;
    $output = `/bin/chown -R $user.admin /home/$user`;
    $output = `/bin/chmod 700 /home/$user`;


  }

  ### ###############################################################
  ### update_passwd(user, pass);
  ### ###############################################################
  ### Updates the password file with the new password for user.
  ### ###############################################################

  sub update_passwd {
    $SHADOW = "/etc/shadow";
    ($user, $pass) = @_;

    ### Backup shadow.
    $output = `/bin/cp -u /etc/shadow /etc/shadow.bak`;

    ### Get time since epoch.
    $sp_lstchg = int(time() / (60*60*24));

    ### Read in shadow file.
    open SHADOW, "/etc/shadow";
      @FILE = <SHADOW>;
    close SHADOW;

    ### Replace desired line with updated information.
    foreach (@FILE) {
      if ($_ =~ /^$user\:/) {
        $_ = "$user:$pass:$sp_lstchg:0:99999:7:-1:-1:\n";
      }
    }


    ### Get the lock & open file.
    &obtain_lock($SHADOW);
    open SHADOW, ">/etc/shadow";

      ### Re-write file.
      foreach (@FILE) { print SHADOW $_; }

    ### Close the file & release lock.
    close SHADOW;
    &release_lock($SHADOW);
    
  }


  ### ###############################################################
  ### GetNextUID()
  ### ###############################################################
  ### Returns the next UID to be used.
  ### ###############################################################

  sub GetNextUID {
    $MAX_UID = 0;

    setpwent();
      while (@tmp = getpwent()) {
        if ($tmp[2] > $MAX_UID) { $MAX_UID = $tmp[2]; }
      }
    endpwent();

    if ($MAX_UID < 500) { $MAX_UID = 500; }
    $MAX_UID++;

    return ($MAX_UID);
  }


  ### ###############################################################
  ### GetNextGID()
  ### ###############################################################
  ### Returns the next GID to be used.
  ### ###############################################################

  sub GetNextGID {
    $MAX_GID = 0;

    setpwent();
      while (@tmp = getpwent()) {
        if ($tmp[3] > $MAX_GID) { $MAX_GID = $tmp[3]; }
      }
    endpwent();

    $MAX_GID++;
    return ($MAX_GID);
  }


  ### ###############################################################
  ### PrintError()
  ### ###############################################################
  ### Used to pop up a JavaScript with a $message then return user to
  ### previous page.
  ### ###############################################################

  sub PrintError {
    my ($message, $level) = @_;

    if (!$level) { $level = "-1"; }

    print <<ErrorEOF;
Content-type: text/html


<HTML>
<HEAD>
  <TITLE> </TITLE>

  <SCRIPT LANGUAGE="JavaScript">
    alert("$message");
    history.go($level);
  </SCRIPT>
</HEAD>
</HTML>
ErrorEOF
  }

  ### ###############################################################
  ### encrypt_password()
  ### ###############################################################
  ### Used to md5 crypt a password.
  ### ###############################################################
sub encrypt_password {
  eval "use MD5";

  local $passwd = $_[0];
  local $magic = '$1$';
  local $salt = substr(time(), -8);

  # Add the password, magic and salt
  local $ctx = new MD5;
  $ctx->add($passwd);
  $ctx->add($magic);
  $ctx->add($salt);

  # Add some more stuff from the hash of the password and salt
  local $ctx1 = new MD5;
  $ctx1->add($passwd);
  $ctx1->add($salt);
  $ctx1->add($passwd);
  local $final = $ctx1->digest();

  for($pl=length($passwd); $pl>0; $pl-=16) {
    $ctx->add($pl > 16 ? $final : substr($final, 0, $pl));
  }


  # This piece of code seems rather pointless, but it's in the C code that
  # does MD5 in PAM so it has to go in!
  local $j = 0;
  local ($i, $l);
  for($i=length($passwd); $i; $i >>= 1) {
  if ($i & 1) {
  $ctx->add("\0");
  }
  else {
  $ctx->add(substr($passwd, $j, 1));
  }
  }
  $final = $ctx->digest();

  # This loop exists only to waste time
  for($i=0; $i<1000; $i++) {
  $ctx1 = new MD5;
  $ctx1->add($i & 1 ? $passwd : $final);
  $ctx1->add($salt) if ($i % 3);
  $ctx1->add($passwd) if ($i % 7);
  $ctx1->add($i & 1 ? $final : $passwd);
  $final = $ctx1->digest();
  }

  # Convert the 16-byte final string into a readable form
  local $rv = $magic.$salt.'$';

  local @final = map { ord($_) } split(//, $final);
  $l = ($final[ 0]<<16) + ($final[ 6]<<8) + $final[12];
  $rv .= &to64($l, 4);
  $l = ($final[ 1]<<16) + ($final[ 7]<<8) + $final[13];
  $rv .= &to64($l, 4);
  $l = ($final[ 2]<<16) + ($final[ 8]<<8) + $final[14];
  $rv .= &to64($l, 4);

  $l = ($final[ 3]<<16) + ($final[ 9]<<8) + $final[15];
  $rv .= &to64($l, 4);
  $l = ($final[ 4]<<16) + ($final[10]<<8) + $final[ 5];
  $rv .= &to64($l, 4);
  $l = $final[11];
  $rv .= &to64($l, 2);

  return $rv;
}


sub to64 {
  @itoa64 = split(//, "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
  local ($v, $n) = @_;
  local $r;
  while(--$n >= 0) { $r .= $itoa64[$v & 0x3f]; $v >>= 6; }
  return $r;
}
