#!/usr/bin/perl

  ### Startup stuff.
  require './web-lib.pl';
  &init_config();

  ### If we have not been configured yet, then take us to the INITCONFIG module.
  if (! system "rpm -q WebTool-INITCONFIG > /dev/null 2>&1") {
    &redirect("/INITCONFIG/");
    exit;
  }


  ### Init some variables.
  $hostname = &get_system_hostname();
  $ver = &get_webmin_version();
  &get_miniserv_config(\%miniserv);


  ### Determine OS version.
  if ($gconfig{'real_os_type'}) {
    $ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
  }
  else { $ostr = "$gconfig{'os_type'} $gconfig{'os_version'}"; }


  ### Build a list of all modules
  &read_acl(\%acl);

  $user = $ENV{'REMOTE_USER'};
  opendir(DIR, ".");
  foreach $d (readdir(DIR)) {
    local %minfo;

    if ($d !~ /^config-/ && (%minfo = &get_module_info($d))) {
      ### Verify this module has support for current OS.
      if (!&check_os_support(\%minfo)) {
        # This OS is not supported!
        next;
      }

      ### User cannot access module, so skip.
      if (!$acl{$user,$d} && !$acl{$user,"*"}) {
        # This user has no access
        next;
      }

      ### Add this module to @modules.
      push(@modules, \%minfo);
    }
  }
  closedir(DIR);


  ### Sort the modules.
  @modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;


  ## If the user has one module, take them directly there.
  if (@modules == 1 && $gconfig{'gotoone'}) {
    # Redirect into a single module
    &redirect($modules[0]->{'dir'}.'/');
    exit;
  }


  ### ####################### ###
  ### Ryan's custom GD index. ###
  ### ####################### ###
  &header("The Guardian Digital WebTool -- Guardian Digital, Inc.");

print "<TABLE WIDTH=\"707\" BORDERr=\"0\">\n";
print "<TR>\n";
print "<TD WIDTH=\"25\">&nbsp;</td>\n";
print "<TD WIDTH=\"647\">\n";

  print "<TABLE BORDER=\"0\" WIDTH=\"100%\">\n";
  print "  <TR>\n";
  print "    <TD WIDTH=60% ALIGN=center>\n";
  print "      <IMG SRC=\"images/WebTool/head.gif\" BORDER=0>\n";
  print "    </TD>\n\n";
  print "  </TR>\n";
  print "</TABLE>\n\n";


  ### ################## ###
  ### BEGIN Module stuff ###
  ### ################## ###

  if (! system "rpm -q WebTool-VHost > /dev/null 2>&1") {
    print <<ADMINTABLE01;

  <CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0">
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="VHost/"><IMG SRC="images/WebTool/virtualhostmanagement.gif" BORDER="0"></A>
      </TD>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemManager/"><IMG SRC="images/WebTool/systemmanagement.gif" BORDER="0"></A>
      </TD>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="StatusMonitor/"><IMG SRC="images/WebTool/statusmonitor.gif" BORDER="0"></A>
      </TD>
    </TR>

    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>

    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="Security/"><IMG SRC="images/WebTool/security.gif" BORDER="0"></A>
      </TD>
ADMINTABLE01

  if (! system "rpm -q WebTool-gdupdate > /dev/null 2>&1") {
    print "      <TD ALIGN=\"CENTER\" WIDTH=\"33%\">\n";
    print "        <A HREF=\"gdupdate/\"><IMG SRC=\"images/WebTool/gdupdate.gif\" BORDER=\"0\"></A>\n";
    print "      </TD>\n";
  }
  else { print "      <TD WIDTH=\"33%\">&nbsp;</TD>\n"; }

print <<ADMINTABLE02;
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemBackup/"><IMG SRC="images/WebTool/systembackup.gif" BORDER="0"></A>
      </TD>
    </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
  </TABLE></CENTER>
ADMINTABLE02
  }

  else {
    print <<ADMINTABLE01;
  <CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0">
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemManager/"><IMG SRC="images/WebTool/systemmanagement.gif" BORDER="0"></A>
      </TD>

      <TD WIDTH="33%">&nbsp;</TD>

      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="StatusMonitor/"><IMG SRC="images/WebTool/statusmonitor.gif" BORDER="0"></A>
      </TD>
    </TR>

    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>

    <TR>
      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="Security/"><IMG SRC="images/WebTool/security.gif" BORDER="0"></A>
      </TD>

ADMINTABLE01

  if (! system "rpm -q WebTool-gdupdate > /dev/null 2>&1") {
    print "      <TD ALIGN=\"CENTER\" WIDTH=\"33%\">\n";
    print "        <A HREF=\"gdupdate/\"><IMG SRC=\"images/WebTool/gdupdate.gif\" BORDER=\"0\"></A>\n";
    print "      </TD>\n";
  }
  else { print "      <TD WIDTH=\"33%\">&nbsp;</TD>\n"; }

print <<ADMINTABLE02;

      <TD ALIGN="CENTER" WIDTH="33%">
        <A HREF="SystemBackup/"><IMG SRC="images/WebTool/systembackup.gif" BORDER="0"></A>
      </TD>
    </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
    <TR> <TD COLSPAN="3">&nbsp;</TD> </TR>
  </TABLE></CENTER>
ADMINTABLE02
  }

  ### ############################ ###
  ### Print our own custom footer. ###
  ### ############################ ###

&ryanFooter("session_login.cgi?logout=1");
